//+------------------------------------------------------------------+
//|                                                         Calc.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
/*     .
     :    3    OPEN, STOP, PROFIT;
            
   (OPEN),   (STOP)  - (PROFIT).   
      ,    (calc_lots)  
     (comission)   CFD,     
    (      ,  CFD    
   ).           
    ( ) ,   ,     
              
    .
            .*/
//+---------------------------------------------------------------------------------+
#property description "   /  "
#property description  "  ,    "
#property description  "OPEN, STOP, PROFIT   "
//---
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

//--- input parameters
input double calc_lots=1.0;
input double comission=0.0;
//---
input color  clrOpen=clrWhite;
input color  clrStop=clrYellow;
input color  clrProfit=clrAqua;
input color  clrStopout=clrRed;
//---
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <ChartObjects\ChartObjectsLines.mqh>
//---
CAccountInfo account;
CSymbolInfo  sym;
//---
CChartObjectHLine OPEN,STOP,PROFIT,STOPOUT;
//---
double xxx=1;
bool flgExit=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   sym.Name(_Symbol); 
   sym.Refresh(); 
   return(init());
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,      //   price[]
                 const int prev_calculated,  //     
                 const int begin,            //    
                 const double& price[]       //   
                 )
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_DRAG)
     {
      if(sparam=="OPEN" || sparam=="STOP" || sparam=="PROFIT") { start(); }
     }
  }
//+------------------------------------------------------------------+
double stopout_level; //  
double proff,preproff,preloss,kurs;
double loss,start_margin,calc_margin,stopout_lvl2,stopout_lvl,marginsum;
//---
double
tikk_vp, //     
tikk_vl, //     
tikk_s,  //  
tikk_l;  //   
//---
ENUM_SYMBOL_CALC_MODE tikk_m; //   
ENUM_ACCOUNT_INFO_INTEGER leverage_lev; // 
//---
string comnts="";
string XXX="";                      //-   
string YYY="";                      //-   
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int init()
  {
   long chartID=ChartID();
   long ind_total=ChartIndicatorsTotal(chartID,0);
   int ind_cnt=0;
   for(long i=0;i<ind_total;i++)
     {
      if(ChartIndicatorName(chartID,0,(int)i)!=MQL5InfoString(MQL5_PROGRAM_NAME)) 
       continue;
      ind_cnt++;
     }
   if(ind_cnt>1)
    {
     Alert(" CalcRiskProfit     ",_Symbol,"\n","   !");
     return(-1);
    }     
//---
   tikk_vp = sym.TickValueProfit(); // SYMBOL_TRADE_TICK_VALUE_LOSS -      
   tikk_vl = sym.TickValueLoss();   // SYMBOL_TRADE_TICK_VALUE_LOSS -      
   tikk_s  = sym.TickSize();        // SYMBOL_TRADE_TICK_SIZE -   
   tikk_m  = sym.TradeCalcMode();   // SYMBOL_TRADE_CALC_MODE -     
   tikk_l  = sym.ContractSize();    // SYMBOL_TRADE_CONTRACT_SIZE -   
//---
// ACCOUNT_MARGIN_SO_SO -   ,          (Stop Out).
//     ACCOUNT_MARGIN_SO_MODE       
   stopout_level=account.MarginStopOut();
//---
   leverage_lev=(ENUM_ACCOUNT_INFO_INTEGER) account.Leverage(); // ACCOUNT_LEVERAGE -   
//---
// SYMBOL_MARGIN_INITIAL -  ()                .
//         .
   start_margin=calc_lots*sym.MarginInitial();

//    .
//            ,    .
//          .     0,    .
   calc_margin=calc_lots*sym.MarginMaintenance();
//---
   if(calc_margin<=0) { calc_margin=calc_lots*tikk_l/leverage_lev; }
//---
   sym.RefreshRates();
//---
   int shift=20;
   switch(_Period)
     {
       case PERIOD_M1:
       case PERIOD_M2:
       case PERIOD_M3:
       case PERIOD_M4:
       case PERIOD_M5:
       case PERIOD_M6:
        shift=5;break;
       case PERIOD_H4:
       case PERIOD_H6:
       case PERIOD_H8:
       case PERIOD_H12:
       case PERIOD_D1:
        shift=100;break;
       case PERIOD_W1:
       case PERIOD_MN1:
        shift=500;
      }
   if(sym.Digits()==5||sym.Digits()==3)
     shift*=10;     
   double bid=sym.Bid();
//---
//          (Broco):
   kurs = 1;
   XXX=StringSubstr(_Symbol,0,3);
   YYY=StringSubstr(_Symbol,3,3);
   
//    
    if(tikk_m==SYMBOL_CALC_MODE_FOREX)         //  ()
     if(StringFind(_Symbol,"USD",0)==-1)       //   XXXYYY (, GBPJPY).       "USD"
     {
      string curSymbol="";
      int symbolNumber=SymbolsTotal(false);    //-    
      for(int i=0;i<=symbolNumber;i++)         //-      XXX
        {
         curSymbol=SymbolName(i,false);        //-    
         if(curSymbol==XXX+"USD")              //-   XXXUSD ?
            break;
         else
            if(curSymbol=="USD"+XXX)           //-   USDXXX ? 
              break;           
        }              
      SymbolSelect(curSymbol,true);
      for(int i=0;i<=symbolNumber;i++)         //-      YYY
        {
         curSymbol=SymbolName(i,false);        //-    
         if(curSymbol==YYY+"USD")              //-   YYYUSD ?
            break;
         else
           if(curSymbol=="USD"+YYY)           //-   USDYYY ?
             break;
        }
      SymbolSelect(curSymbol,true);
     }
//    
   ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,true); //    
//---
   if(ObjectFind(0,"OPEN")== -1) { OPEN.Create(ChartID(),"OPEN",0,bid); }
   if(ObjectFind(0,"STOP")== -1) { STOP.Create(ChartID(),"STOP",0,bid-shift*_Point); }
   if(ObjectFind(0,"PROFIT")==-1) { PROFIT.Create(ChartID(),"PROFIT",0,bid+shift*_Point); }
   if(ObjectFind(0,"STOPOUT")==-1) { STOPOUT.Create(ChartID(),"STOPOUT",0,-1.0); }
//---
   OPEN.Selectable(true); STOP.Selectable(true); PROFIT.Selectable(true); //  
   OPEN.Selected(true); STOP.Selected(true); PROFIT.Selected(true); //  
   OPEN.Color(clrOpen); STOP.Color(clrStop); PROFIT.Color(clrProfit); STOPOUT.Color(clrStopout); //  
//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");
  };
//+------------------------------------------------------------------+
//| _                                                    |
//+------------------------------------------------------------------+
int start()
  {
   sym.RefreshRates();
//---
   double bid=sym.Bid();
   double ask=sym.Ask();
   double open=OPEN.Price(0);
   double stop=STOP.Price(0);
   double profit=PROFIT.Price(0);
   double balance=account.Balance();

//   
   preloss=kurs*fabs(open-stop); // 
   preproff=kurs*fabs(open-profit); // 
   marginsum=((100-stopout_level)/100)*fabs(balance-calc_margin);
//---
   switch(tikk_m) //      
     {
      //+------------------------------------------------------------------+
      //| FOREX -                                                    |
      //+------------------------------------------------------------------+
      case SYMBOL_CALC_MODE_FOREX:
         //---
         start_margin=0;
         if(YYY=="USD")             //  XXXUSD ( )
           {
/*           proff=account.OrderProfitCheck(_Symbol,ORDER_TYPE_BUY,calc_lots,open,profit);
           if(proff==EMPTY_VALUE)
            Print("error=",GetLastError());*/
           loss=account.OrderProfitCheck(_Symbol,ORDER_TYPE_BUY,calc_lots,open,stop);
           proff= preproff*calc_lots*tikk_l;
           loss = preloss*calc_lots*tikk_l;
            //---
            stopout_lvl=open+marginsum/(calc_lots*tikk_l);
            stopout_lvl2=open-marginsum/(calc_lots*tikk_l);
            //---
            if(start_margin<=0) { start_margin=calc_margin*bid; }
           }
         //---
         if(XXX=="USD") //  USDYYY ( )
           {
            proff= preproff*calc_lots*tikk_l/profit;
            loss = preloss*calc_lots*tikk_l/stop;
            //---
            marginsum=((100-stopout_level)/100)*fabs(balance-calc_margin/bid);
            //---
            stopout_lvl=open+marginsum/(calc_lots*tikk_l/bid);
            stopout_lvl2=open-marginsum/(calc_lots*tikk_l/bid);
            //---
            if(start_margin<=0)  
             start_margin=calc_margin; 
           }
         //---
         if(StringFind(_Symbol,"USD",0)==-1) //  (, GBPJPY).       "USD"
           {
            if(SymbolInfoDouble("USD"+YYY,SYMBOL_BID)>0) // ,     "USDYYY"
              {
               double tmpinfo=SymbolInfoDouble("USD"+YYY,SYMBOL_BID);
               //---
               marginsum=((100-stopout_level)/100)*fabs(balance-calc_margin/tmpinfo);
               //---
               proff= preproff*calc_lots*tikk_l/tmpinfo;
               loss = preloss*calc_lots*tikk_l/tmpinfo;
               //---
               stopout_lvl=open+marginsum/(calc_lots*tikk_l/tmpinfo);
               stopout_lvl2=open-marginsum/(calc_lots*tikk_l/tmpinfo);
               //---
               if(start_margin<=0) 
                start_margin=calc_margin/tmpinfo*bid;
              }
            else
              {
                if(SymbolInfoDouble(XXX+"USD",SYMBOL_BID)>0) // ,     "XXXUSD"
                 {
                  double tmpinfo=SymbolInfoDouble(XXX+"USD",SYMBOL_BID);
                  //---
                  marginsum=((100-stopout_level)/100)*fabs(balance-calc_margin*tmpinfo);
                  //---
                  proff= preproff*calc_lots*tikk_l*tmpinfo/bid;
                  loss = preloss*calc_lots*tikk_l*tmpinfo/bid;
                  //---
                  stopout_lvl=open+marginsum/(calc_lots*tikk_l*tmpinfo/bid);
                  stopout_lvl2=open-marginsum/(calc_lots*tikk_l*tmpinfo/bid);
                  //---
                  if(start_margin<=0) 
                   start_margin=calc_margin*tmpinfo;
                 }
                else
                   Print("No data for symbol ",_Symbol);
              }
           }
         break;
      //---
      //+------------------------------------------------------------------+
      //| CFD -                                                       |
      //+------------------------------------------------------------------+
      case SYMBOL_CALC_MODE_CFD: // CFD 
         //---
         proff = preproff*calc_lots*tikk_l - (comission/100)*calc_lots*open;
         loss  = preloss*calc_lots*tikk_l  + (comission/100)*calc_lots*open;
         //---
         stopout_lvl=open+(marginsum-(comission/100)*calc_lots*open)/(calc_lots*tikk_l);
         stopout_lvl2=open -(marginsum-(comission/100)*calc_lots*open)/(calc_lots*tikk_l);
         break;
      //---
      //+------------------------------------------------------------------+
      //| FUTURES -                                                |
      //+------------------------------------------------------------------+
      default: // 
         //---
         proff=(preproff*calc_lots*tikk_vp/tikk_s)-(calc_lots*comission);
         loss =(preloss*calc_lots*tikk_vl/tikk_s)+(calc_lots*comission);
         //---
         stopout_lvl=open+(marginsum/kurs-calc_lots*comission)/(calc_lots*tikk_vp/tikk_s);
         stopout_lvl2=open -(marginsum/kurs-calc_lots*comission)/(calc_lots*tikk_vl/tikk_s);
         //---
         marginsum=marginsum/kurs;
     }

//   
   if(open>profit)
     {
      if(ObjectFind(0,"STOPOUT")==-1) { STOPOUT.Create(ChartID(),"STOPOUT",0,stopout_lvl); }
      //---
      STOPOUT.Price(0,stopout_lvl);
     }
   else
     {
      if(ObjectFind(0,"STOPOUT")==-1) { STOPOUT.Create(ChartID(),"STOPOUT",0,stopout_lvl2); }
      //---
      STOPOUT.Price(0,stopout_lvl2);
     }

//    
   ObjectSetString(0,"STOP",OBJPROP_TEXT,"Stop "+DoubleToString(loss,2));
   ObjectSetString(0,"PROFIT",OBJPROP_TEXT,"Profit "+DoubleToString(proff,2));
   ObjectSetString(0,"OPEN",OBJPROP_TEXT,"Open "+DoubleToString(calc_lots,2)+" ");
   ObjectSetString(0,"STOPOUT",OBJPROP_TEXT,"  -"+DoubleToString(marginsum,2)+"USD");

//       
   comnts=" "+DoubleToString(calc_lots,2)+"  \n"+
          ": "+DoubleToString(proff,2)+" ("+DoubleToString(proff*100/account.Equity(),2)+"%) \n"+
          ": "+DoubleToString(loss,2)+" ("+DoubleToString(loss*100/account.Equity(),2)+"%) \n";
//---
   if(start_margin>0) { comnts = comnts + " : "+DoubleToString(start_margin,2)+" USD \n"; }
   if(leverage_lev>0) { comnts = comnts + ": " + DoubleToString(leverage_lev,2); }
//---
   Comment(comnts); return(0);
  }
//+------------------------------------------------------------------+
